unit gest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Math, ExtCtrls, IniFiles, ComCtrls, Menus, ShellAPI, Spin;

const WM_NOTIFYTRAYICON = WM_USER + 2;

type
  TtPshSqWjOIjq = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    List1: TListBox;
    Button3: TButton;
    List2: TListBox;
    OD: TOpenDialog;
    Timer1: TTimer;
    HK: THotKey;
    CB: TCheckBox;
    PM: TPopupMenu;
    Exit1: TMenuItem;
    Restore1: TMenuItem;
    CB2: TCheckBox;
    Act: TPopupMenu;
    N1: TMenuItem;
    Button4: TButton;
    GB: TGroupBox;
    UseMouse: TCheckBox;
    UseLeft: TRadioButton;
    UseRight: TRadioButton;
    UseMiddle: TRadioButton;
    MSL: TComboBox;
    N2: TMenuItem;
    Button5: TButton;
    Button6: TButton;
    Lang: TComboBox;
    SE: TSpinEdit;
    Timer2: TTimer;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure List2DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CBClick(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SEChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Restore1Click(Sender: TObject);
    procedure CB2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UseMouseClick(Sender: TObject);
    procedure UseLeftClick(Sender: TObject);
    procedure UseMiddleClick(Sender: TObject);
    procedure UseRightClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure List1DblClick(Sender: TObject);
    procedure List1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LangChange(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    procedure HotKey(var Msg: TMessage); message WM_HOTKEY;
    procedure Hook(var Msg: TMessage); message WM_USER+121;
    procedure TrayIcon(var soobch: TMessage); message WM_NOTIFYTRAYICON;
    procedure Minz(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  tPshSqWjOIjq: TtPshSqWjOIjq;
  pnt, pnt2: TPoint;
  s: Array [0..100] of boolean;
  gst: Array [0..100, 0..100] of integer;
  s2: Array [0..100] of Integer;
  a: Array[0..100] of String;
  s3: Array[0..100] of Integer;
  inif: TIniFile;
  t,e,p,b,b2,r2,u,xx,yy,xx2,yy2,x2,y2,tx,ty,max,m: Integer;
  dx, dy, d: single;
  q, fl, HKU, sh, mv, clc: boolean;
  o, CurDir, RDir: String;
  y: TRect;
  tray: TNotifyIconData;
  d2: single;
  modif: Integer;
  ss: TShiftState;
  K: Word;
  Edit, Lock: Boolean;
  Count, m1, m2, m3, m4, b1, b21: Cardinal;
  n: Cardinal;
  CL: Integer;
  const w: integer=45; //angle of deviation
        ch: integer=30; //record sensitivity
        f: Boolean=True;
        ver: String='1.4';

implementation

{$R *.DFM}

function InstallHook: Cardinal; stdcall; external 'FTV';
procedure UnInstallHook; stdcall; external 'FTV';
procedure UnInstallHookKB; stdcall; external 'FTV';
function ParseScript(Str: PChar): Boolean; stdcall; external 'parser.dll';

function CutStr(Str: String; WordNum: Integer): String;
var Pss: Integer;
    NMW: Integer;
begin
pss:=0;
Result:='';
While WordNum>0 do begin
        Inc(Pss);
        NMW:=Pss;
        while (Pss<Length(str)) and (Str[Pss]<>';') do Inc(Pss);
        Dec(WordNum);
        if (Pss=Length(str)) and (WordNum>0) then Exit;
        if Pss=Length(str) then break;
end;
Result:=Copy(Str, NMW, Pss-NMW);
end;

procedure SetMessages(Button: Cardinal);
begin
case Button of
        1: begin
                m1:=WM_LBUTTONDOWN;
                m2:=WM_NCLBUTTONDOWN;
                m3:=WM_LBUTTONUP;
                m4:=WM_NCLBUTTONUP;
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run left');
                SetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run middle');
                ResetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run right');
                ResetEvent(n);
                CloseHandle(n);
        end;
        2: begin
                m1:=WM_MBUTTONDOWN;
                m2:=WM_NCMBUTTONDOWN;
                m3:=WM_MBUTTONUP;
                m4:=WM_NCMBUTTONUP;
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run left');
                ResetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run middle');
                SetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run right');
                ResetEvent(n);
                CloseHandle(n);
        end;
        3: begin
                m1:=WM_RBUTTONDOWN;
                m2:=WM_NCRBUTTONDOWN;
                m3:=WM_RBUTTONUP;
                m4:=WM_NCRBUTTONUP;
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run left');
                ResetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run middle');
                ResetEvent(n);
                CloseHandle(n);
                n:=OpenEvent(EVENT_ALL_ACCESS, False, 'Sign&Run right');
                SetEvent(n);
                CloseHandle(n);
        end;
end;
Application.ProcessMessages;
end;

procedure Hd;
begin
ShowWindow(tPshSqWjOIjq.Handle, SW_HIDE);
ShowWindow(Application.Handle, SW_HIDE);
end;

procedure Shw;
begin
ShowWindow(tPshSqWjOIjq.Handle, SW_SHOW);
ShowWindow(Application.Handle, SW_SHOW);
end;

procedure TtPshSqWjOIjq.Hook(var Msg: TMessage);
begin
Application.ProcessMessages;
if ((Msg.lParam and $80000000)>0) and (Msg.WParam=$10) and Lock then begin
        Lock:=False;
        UseMouse.Checked:=True;
        Exit;
end;
if ((Msg.lParam and $80000000)=0) and (Msg.WParam=$10) and UseMouse.Checked then begin
        Lock:=True;
        UseMouse.Checked:=False;
        Exit;
end;
if UseMouse.Checked then begin
        if (Msg.WParam=m1) or (Msg.WParam=m2) then begin
                f:=True;
                Button1.Click;
        end;
        if (Msg.WParam=m3) or (Msg.WParam=m4) then begin
                f:=False;
                Button1.Click;
        end;
end;
end;

procedure Drawing;
begin
if tPshSqWjOIjq.List1.ItemIndex>=0 then begin
        tPshSqWjOIjq.Image1.Canvas.Pen.Color:=clBlack;
        tPshSqWjOIjq.Image1.Canvas.FillRect(y);
        xx:=x2;
        yy:=y2;
        tPshSqWjOIjq.Image1.Canvas.Brush.Style:=bsSolid;
        tPshSqWjOIjq.Image1.Canvas.Brush.Color:=clBlue;
        tPshSqWjOIjq.Image1.Canvas.Ellipse(xx-3, yy-3, xx+3, yy+3);
        tPshSqWjOIjq.Image1.Canvas.Brush.Color:=clWhite;
        tPshSqWjOIjq.Image1.Canvas.MoveTo(xx, yy);
        For t:=0 to s2[tPshSqWjOIjq.List1.ItemIndex]-1 do begin
                xx:=xx+Round(cos(gst[tPshSqWjOIjq.List1.ItemIndex, t]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                yy:=yy-Round(sin(gst[tPshSqWjOIjq.List1.ItemIndex, t]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                With tPshSqWjOIjq.Image1.Canvas do begin
                        LineTo(xx, yy);
                        Pen.Color:=clRed;
                        LineTo(xx+Round(cos((gst[tPshSqWjOIjq.List1.ItemIndex, t]+160)/180*pi)*5), yy-Round(sin((gst[tPshSqWjOIjq.List1.ItemIndex, t]+160)/180*pi)*5));
                        MoveTo(xx, yy);
                        LineTo(xx+Round(cos((gst[tPshSqWjOIjq.List1.ItemIndex, t]-160)/180*pi)*5), yy-Round(sin((gst[tPshSqWjOIjq.List1.ItemIndex, t]-160)/180*pi)*5));
                        MoveTo(xx, yy);
                        Pen.Color:=clBlack;
                end;
        end;
end;
end;

procedure advrec;
begin
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt.x-tPshSqWjOIjq.Left-tPshSqWjOIjq.Width+tPshSqWjOIjq.ClientWidth+5-xx;
        dy:=yy-(pnt.y-tPshSqWjOIjq.Top-tPshSqWjOIjq.Height+tPshSqWjOIjq.ClientHeight+5);
        d:=(arctan(dy/(dx+0.1))*180/Pi);
        d:=ch*(Round(d/ch));
        if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
        if d=360 then d:=0;
        if clc then begin
                clc:=False;
                xx:=tx;
                yy:=ty;
                tPshSqWjOIjq.Image1.Canvas.MoveTo(xx, yy);
                tx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                ty:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx, ty);
                tPshSqWjOIjq.Image1.Canvas.Pen.Color:=clRed;
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]+160)/180*pi)*5), ty-Round(sin((gst[P, B]+160)/180*pi)*5));
                tPshSqWjOIjq.Image1.Canvas.MoveTo(tx, ty);
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]-160)/180*pi)*5), ty-Round(sin((gst[P, B]-160)/180*pi)*5));
                tPshSqWjOIjq.Image1.Canvas.MoveTo(xx, yy);
                tPshSqWjOIjq.Image1.Canvas.Pen.Color:=clBlack;
                inc(b);
                s2[p]:=b;
        end;
                Drawing;
                gst[p, b]:=Round(d);
                d2:=d;
                tPshSqWjOIjq.Image1.Canvas.MoveTo(xx, yy);
                tx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                ty:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(tPshSqWjOIjq.SE.Text));
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx, ty);
                tPshSqWjOIjq.Image1.Canvas.Pen.Color:=clRed;
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]+160)/180*pi)*5), ty-Round(sin((gst[P, B]+160)/180*pi)*5));
                tPshSqWjOIjq.Image1.Canvas.MoveTo(tx, ty);
                tPshSqWjOIjq.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]-160)/180*pi)*5), ty-Round(sin((gst[P, B]-160)/180*pi)*5));
                tPshSqWjOIjq.Image1.Canvas.MoveTo(xx, yy);
                tPshSqWjOIjq.Image1.Canvas.Pen.Color:=clBlack;
        Application.ProcessMessages;
        Sleep(1);
end;
if CL=1 then tPshSqWjOIjq.Button2.Caption:='';
if CL=0 then tPshSqWjOIjq.Button2.Caption:='Record';
tPshSqWjOIjq.Button3.Enabled:=True;
end;

procedure TtPshSqWjOIjq.Minz(Sender: TObject);
begin
Application.Restore;
ShowWindow(Application.Handle, SW_HIDE);
ShowWindow(tPshSqWjOIjq.Handle, SW_HIDE);
end;

procedure TtPshSqWjOIjq.TrayIcon(var soobch: TMessage);
var p: TPoint;
begin
if soobch.LParam=WM_LBUTTONDOWN then begin
        Shw;
        SetForegroundWindow(tPshSqWjOIjq.Handle);
end;
if soobch.LParam=WM_RBUTTONDOWN then begin
        SetForegroundWindow(tPshSqWjOIjq.Handle);
        GetCursorPos(p);
        PM.Popup(p.x, p.y);
end;
end;

procedure TtPshSqWjOIjq.HotKey(var Msg: TMessage);
begin
Button1.Click;
end;

function gestr(r: integer; n: integer): boolean;
begin
dx:=pnt.x-pnt2.x;
dy:=pnt2.y-pnt.y;
if dx=0 then dx:=0.0000001;
d:=Round(arctan(dy/dx)*180/Pi);
if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
if (abs(gst[r,n]-d)<w) or (abs(gst[r,n]-d+360)<w) then begin
        Result:=True;
        exit;
end;
Result:=False;
end;

procedure TtPshSqWjOIjq.Button1Click(Sender: TObject);
var C: Boolean;
begin
UnRegisterHotKey(tPshSqWjOIjq.handle, $8760);
if not CB.Checked then HK.HotKey:=0;
modif:=0;
if (hkCtrl in HK.Modifiers) then modif:=modif+MOD_CONTROL;
if (hkAlt in HK.Modifiers) then modif:=modif+MOD_ALT;
if (hkShift in HK.Modifiers) then modif:=modif+MOD_SHIFT;
ShortCutToKey(HK.HotKey, K, SS);
if k=0 then UnRegisterHotKey(tPshSqWjOIjq.handle, $8760) else if not RegisterHotKey(tPshSqWjOIjq.Handle, $8760, Modif, k) then begin
        if CL=1 then Application.MessageBox('  !', '!', MB_OK+MB_ICONERROR);
        if CL=0 then Application.MessageBox('Invalid key specified!', 'Error!', MB_OK+MB_ICONERROR);
        HK.enabled:=true;
        UnRegisterHotKey(tPshSqWjOIjq.Handle, $8760);
        HK.SetFocus;
        exit;
end;
f:=not f;
GetCursorPos(pnt2);
if not f then begin
        if CL=1 then Button1.Caption:='';
        if CL=0 then Button1.Caption:='Waiting...';
        Tray.hIcon:=LoadIcon(0, IDI_QUESTION);
        Shell_NotifyIcon(NIM_MODIFY, Addr(tray));
end
else
begin
        if CL=1 then Button1.Caption:='';
        if CL=0 then Button1.Caption:='Start';
        Tray.hIcon := tPshSqWjOIjq.Icon.Handle;
        Shell_NotifyIcon(NIM_MODIFY, Addr(tray));
end;
u:=0;
for t:=0 to p-1 do s3[t]:=0;
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt2.x-pnt.x;
        dy:=pnt2.y-pnt.y;
        if Sqrt(dx*dx+dy*dy)>20 then begin
                max:=0;
                for e:=0 to p-1 do begin
                        if s3[e]>0 then if gestr(e, s3[e]) then begin
                                Inc(s3[e]);
                        end else if not gestr(e, s3[e]-1) then begin
                                s3[e]:=0;
                                Inc(u);
                        end;
                        if s3[e]=0 then if gestr(e, s3[e]) and not Timer1.Enabled then begin
                                Inc(s3[e]);
                                C:=True;
                        end;
                end;
                Pnt2:=Pnt;
                if C then Timer1.Enabled:=True;
        end;
        if u>=p-1 then begin
                u:=0;
                Timer1.Enabled:=False;
        end;
        for e:=0 to p-1 do begin
                if a[e]<>'' then if (s3[e]=s2[e]) then begin
                        for t:=0 to p-1 do s3[t]:=0;
                        List1.ItemIndex:=e;
                        List2.ItemIndex:=e;
                        u:=0;
                        r2:=0;
                        Timer1.Enabled:=False;
                        if a[e][1]='*' then begin
                                if not ParseScript(PChar(a[e])) then MessageBox(tPshSqWjOIjq.Handle, ' Parser''!    ,'+#13#10+'  Parser.dll!', '', MB_ICONSTOP);
                        end
                        else
                        begin
                                RDir:=a[e];
                                while RDir[length(RDir)]<>'\' do RDir:=Copy(RDir, 1, length(RDir)-1);
                                ShellExecute(tPshSqWjOIjq.Handle, nil, PChar(a[e]), nil, PChar(RDir), SW_SHOW);
                        end;
                        Drawing;
                        if HKU then Button1.Click;
                end;
        end;
        Application.ProcessMessages;
        Sleep(10);
end;
end;

procedure TtPshSqWjOIjq.FormCreate(Sender: TObject);
var hm: HMENU;
    v: Boolean;
    CBN: Integer;
begin
GlobalDeleteAtom(GlobalFindAtom('SR0'));
GlobalDeleteAtom(GlobalFindAtom('SR1'));
GlobalDeleteAtom(GlobalFindAtom('SR2'));
CreateEvent(nil, True, True, 'Sign&Run left');
CreateEvent(nil, True, True, 'Sign&Run right');
CreateEvent(nil, True, True, 'Sign&Run middle');
tPshSqWjOIjq.Caption:='Sign&Run v'+ver+' [Created by ShTiRLiC]';
hm:=GetSystemMenu(Application.Handle, False);
DeleteMenu(hm, SC_MINIMIZE, MF_BYCOMMAND);
DeleteMenu(hm, SC_RESTORE, MF_BYCOMMAND);
DeleteMenu(hm, SC_CLOSE, MF_BYCOMMAND);
DeleteMenu(hm, 0, MF_BYPOSITION);
clc:=false;
Inif:=TIniFile.Create('.\gesture.ini');
CL:=0;
if Inif.ReadString('Main', 'Language', 'English')='English' then Lang.ItemIndex:=0 else begin
        Lang.ItemIndex:=1;
        CL:=1;
end;
tPshSqWjOIjq.LangChange(Self);
hm:=Inif.ReadInteger('Main', 'MB', 0);
Inif.Free;
case hm of
        1: begin
                UseLeft.Checked:=True;
        end;
        2: begin
                UseMiddle.Checked:=True;
        end;
        3: begin
                UseRight.Checked:=True;
        end;
end;
Inif:=TIniFile.Create('.\gesture.ini');
v:=Inif.ReadBool('Main', 'UM', False);
Inif.Free;
UseMouse.Checked:=v;
Inif:=TIniFile.Create('.\gesture.ini');
x2:=Inif.ReadInteger('Main', 'x2', 0);
y2:=Inif.ReadInteger('Main', 'y2', 0);
SE.Text:=Inif.ReadString('Main', 'Scale', '15');
if Inif.ReadString('Main', 'HK', 'no')='yes' then begin
        HK.HotKey:=TextToShortCut(Inif.ReadString('Main', 'Hotkey', ''));
        Inif.Free;
        CB.Checked:=True;
end else CB.Checked:=False;
Inif:=TIniFile.Create('.\gesture.ini');
if Inif.ReadString('Main', 'AR', 'no')='yes' then begin
        Inif.Free;
        CB2.Checked:=True;
end else CB2.Checked:=False;
UnRegisterHotKey(tPshSqWjOIjq.handle, $8760);
with tray do begin
        cbSize := SizeOf(tray);
        Wnd := tPshSqWjOIjq.Handle;
        uID := 1;
        uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        uCallBackMessage := WM_NOTIFYTRAYICON;
        hIcon := tPshSqWjOIjq.Icon.Handle;
        szTip := 'Sign Run';
end;
Shell_NotifyIcon(NIM_ADD, Addr(tray));
modif:=0;
if (hkCtrl in HK.Modifiers) then modif:=modif+MOD_CONTROL;
if (hkAlt in HK.Modifiers) then modif:=modif+MOD_ALT;
if (hkShift in HK.Modifiers) then modif:=modif+MOD_SHIFT;
ShortCutToKey(HK.HotKey, K, SS);
if k=0 then UnRegisterHotKey(tPshSqWjOIjq.handle, $8760) else if not RegisterHotKey(tPshSqWjOIjq.Handle, $8760, Modif, k) then begin
        Application.MessageBox('  !', '!', MB_OK+MB_ICONERROR);
        HK.enabled:=true;
        UnRegisterHotKey(tPshSqWjOIjq.Handle, $8760);
        HK.SetFocus;
        exit;
end;
Inif:=TIniFile.Create('.\gesture.ini');
y:=Bounds(0, 0, Image1.Width, Image1.Height);
CurDir:=Application.ExeName;
while CurDir[length(CurDir)]<>'\' do CurDir:=Copy(CurDir, 1, length(CurDir)-1);
p:=Inif.ReadInteger('Main', 'Num', 0);
CBN:=Inif.ReadInteger('Messages', 'NumOfMessages', 0);
for T:=1 to CBN do if Inif.ValueExists('Messages', IntToStr(T)) then begin
        MSL.Items.Add(Inif.ReadString('Messages', IntToStr(T), ''));
end;
for T:=0 to p-1 do begin
        o:=Inif.ReadString('Main', IntToStr(T+1), '');
        e:=1;
        b:=0;
        while e<=Length(o) do begin
                if o[e]=' ' then begin
                        gst[t, b]:=StrToInt(copy(o, 1, e-1));
                        o:=Copy(o, e+1, Length(o)-e);
                        Inc(b);
                        e:=0;
                end;
        Inc(e);
        end;
        if o<>'' then gst[t, b]:=StrToInt(o);
        Inc(b);
        s2[t]:=b;
        a[t]:=Inif.ReadString('Main', 'a'+IntToStr(t), '');
        if o<>'' then begin
                List1.Items.Add(IntToStr(t));
                if a[t]<>'' then begin
                        if a[t][1]='*' then List2.Items.Add(CutStr(a[t], 1)) else List2.Items.Add(a[t]);
                end
                else List2.Items.Add(a[t]);
        end;
end;
Inif.Free;
InstallHook;
end;

procedure TtPshSqWjOIjq.FormKeyPress(Sender: TObject; var Key: Char);
begin
if (key=#8) and (F=False) then begin
        if b>0 then Dec(b) else begin
                f:=true;
                Image1.Canvas.FillRect(y);
                List1.ItemIndex:=p;
                List2.ItemIndex:=p;
                p:=List1.Items.Count;
                Button3.Click;
                exit;
        end;
        s2[p]:=b;
        Drawing;
        d2:=gst[p,b-1];
        pnt2:=pnt;
end;
if (key=#27) and (sh=True) then sh:=False;
if (key=#27) and (F=False) then begin
        f:=true;
        o:='';
        s2[p]:=b;
        Drawing;
        for t:=0 to b-1 do o:=o+IntToStr(gst[p,t])+' ';
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inc(p);
        if o<>'' then begin
                Inif.WriteString('Main', IntToStr(p), o);
                Inif.WriteInteger('Main', 'Num', p);
        end;
        Inif.Free;
end;
end;

procedure TtPshSqWjOIjq.Button2Click(Sender: TObject);
begin
if (Button2.Caption<>'') and (CL=1) then exit;
if (Button2.Caption<>'Record') and (CL=0) then exit;
if CL=1 then Button2.Caption:='';
if CL=0 then Button2.Caption:='Recording...';
Button3.Enabled:=False;
if Edit then begin
        p:=List1.ItemIndex;
        b:=s2[p];
end else b:=0;
f:=False;
Image1.Canvas.FillRect(y);
Image1.Canvas.Pen.Color:=clBlack;
xx:=x2;
yy:=y2;
Image1.Canvas.Brush.Style:=bsSolid;
Image1.Canvas.Brush.Color:=clBlue;
Image1.Canvas.Ellipse(xx-3, yy-3, xx+3, yy+3);
Image1.Canvas.Brush.Color:=clWhite;
d2:=999;
if not Edit then begin
        tPshSqWjOIjq.List1.Items.Add(IntToStr(p));
        tPshSqWjOIjq.List2.Items.Add('');
        tPshSqWjOIjq.List1.ItemIndex:=p;
end else Drawing;
if CB2.Checked then begin
        f:=false;
        advrec;
        Edit:=False;
        exit;
end;
SetCursorPos(Screen.Width div 2, Screen.Height div 2);
GetCursorPos(pnt2);
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt.x-pnt2.x;
        dy:=pnt2.y-pnt.y;
        d:=(arctan(dy/(dx+0.1))*180/Pi);
        d:=ch*(Round(d/ch));
        if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
        if d=360 then d:=0;
        if {(d<>d2) and }(Sqrt(dx*dx+dy*dy)>20) then begin
                gst[p, b]:=Round(d);
                d2:=d;
                pnt2:=pnt;
                Image1.Canvas.MoveTo(xx, yy);
                xx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(SE.Text));
                yy:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(SE.Text));
                Image1.Canvas.LineTo(xx, yy);
                Image1.Canvas.Pen.Color:=clRed;
                Image1.Canvas.LineTo(xx+Round(cos((gst[P, B]+160)/180*pi)*5), yy-Round(sin((gst[P, B]+160)/180*pi)*5));
                Image1.Canvas.MoveTo(xx, yy);
                Image1.Canvas.LineTo(xx+Round(cos((gst[P, B]-160)/180*pi)*5), yy-Round(sin((gst[P, B]-160)/180*pi)*5));
                Image1.Canvas.MoveTo(xx, yy);
                Image1.Canvas.Pen.Color:=clBlack;
                Inc(b);
                s2[p]:=b;
        end;
        Application.ProcessMessages;
        Sleep(1);
end;
if CL=1 then Button2.Caption:='';
if CL=0 then Button2.Caption:='Record';
Button3.Enabled:=True;
Edit:=False;
end;

procedure TtPshSqWjOIjq.Button3Click(Sender: TObject);
begin
If List1.ItemIndex>=0 then begin
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inif.DeleteKey('Main', IntToStr(List1.ItemIndex+1));
        Inif.DeleteKey('Main', 'A'+IntToStr(List1.ItemIndex));
        for t:=List1.ItemIndex+1 to p-1 do begin
                a[t-1]:=a[t];
                gst[t-1]:=gst[t];
                s2[t-1]:=s2[t];
                Inif.WriteString('Main', IntToStr(t), Inif.ReadString('Main', IntToStr(t+1), ''));
                Inif.WriteString('Main', 'a'+IntToStr(t-1), Inif.ReadString('Main', 'a'+IntToStr(t), ''));
                List1.Items[t]:=IntToStr(t-1);
        end;
        Inif.DeleteKey('Main', IntToStr(p));
        Inif.DeleteKey('Main', 'a'+IntToStr(p));
        a[p-1]:='';
        gst[p-1]:=gst[p];
        s2[p-1]:=0;
        Dec(p);
        Inif.WriteInteger('Main', 'Num', P);
        List2.Items.Delete(List1.ItemIndex);
        List1.Items.Delete(List1.ItemIndex);
        Inif.Free;
        Image1.Canvas.FillRect(y);
end;
end;

procedure TtPshSqWjOIjq.List2DblClick(Sender: TObject);
begin
OD.InitialDir:='.';
if OD.Execute then begin
        List2.Items[List2.ItemIndex]:=OD.FileName;
        a[List2.ItemIndex]:=OD.FileName;
        SetCurrentDirectory(PChar(CurDir));
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inif.WriteString('Main', 'A'+IntToStr(List2.ItemIndex), OD.FileName);
        Inif.Free;
end;
end;

procedure TtPshSqWjOIjq.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=False;
for t:=0 to p-1 do s3[t]:=0;
end;

procedure TtPshSqWjOIjq.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
UnInstallHook;
UnInstallHookKB;
f:=True;
sh:=False;
mv:=False;
UnregisterHotKey(tPshSqWjOIjq.Handle, $8760);
Inif:=TIniFile.Create('.\gesture.ini');
Inif.WriteString('Main', 'Hotkey', ShortCutToText(HK.HotKey));
if Lang.ItemIndex>-1 then Inif.WriteString('Main', 'Language', Lang.Items[Lang.ItemIndex]);
Inif.WriteInteger('Main', 'Scale', StrToInt(SE.Text));
Inif.Free;
Shell_NotifyIcon(NIM_DELETE, Addr(tray));
GlobalDeleteAtom(GlobalFindAtom('SR0'));
GlobalDeleteAtom(GlobalFindAtom('SR1'));
GlobalDeleteAtom(GlobalFindAtom('SR2'));
ExitProcess(0);
end;

procedure TtPshSqWjOIjq.FormResize(Sender: TObject);
var w,h: Integer;
begin
W:=tPshSqWjOIjq.ClientWidth;
H:=tPshSqWjOIjq.ClientHeight;
Image1.Width:=W-377;
Image1.Height:=H-89;
HK.Top:=H-50;
Button1.Top:=H-82;
Button2.Top:=H-82;
List2.Left:=W-346;
List1.Left:=W-378;
List1.Height:=H-89;
List2.Height:=H-89;
Button3.Left:=W-346;
Button3.Top:=H-82;
Button4.Left:=W-77;
Button4.Top:=H-82;
GB.Left:=W-269;
GB.Top:=H-87;
CB.Top:=H-47;
CB2.Top:=H-47;
SE.Top:=H-81;
MSL.Top:=H-24;
MSL.Width:=W-171;
Button5.Top:=H-26;
Button5.Left:=W-156;
Button6.Top:=H-26;
Button6.Left:=W-76;
Button7.Top:=H-44;
Button7.Left:=W-232;
Lang.Top:=H-52;
Lang.Left:=W-81;
if fl then begin
        y:=Bounds(0, 0, Image1.Width, Image1.Height);
        Image1.Picture.Bitmap.Width:=Image1.Width;
        Image1.Picture.Bitmap.Height:=Image1.Height;
end;
Drawing;
end;

procedure TtPshSqWjOIjq.FormActivate(Sender: TObject);
begin
fl:=True;
Hd;
if not CB.Checked then Button1.Click;
end;

procedure TtPshSqWjOIjq.CBClick(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
if CB.Checked=True then begin
        Inif.WriteString('Main', 'HK', 'yes');
        HKU:=True;
end else begin
        Inif.WriteString('Main', 'HK', 'no');
        HKU:=False;
        UnRegisterHotKey(tPshSqWjOIjq.handle, $8760);
        HK.HotKey:=0;
end;
Inif.Free;
end;

procedure TtPshSqWjOIjq.List1Click(Sender: TObject);
begin
Drawing;
end;

procedure TtPshSqWjOIjq.Image1DblClick(Sender: TObject);
begin
GetCursorPos(pnt);
xx2:=Pnt.X;
yy2:=Pnt.Y;
sh:=True;
List1.Enabled:=False;
For t:=0 to s2[tPshSqWjOIjq.List1.ItemIndex]-1 do begin
        for b2:=0 to 5 do begin
                if sh=False then begin
                        List1.Enabled:=True;
                        SetCursorPos(Pnt.X, Pnt.Y);
                        exit;
                end;
                SetCursorPos(xx2, yy2);
                xx2:=xx2+Round(cos(gst[tPshSqWjOIjq.List1.ItemIndex, t]/180*pi)*StrToInt(SE.Text)/5);
                yy2:=yy2-Round(sin(gst[tPshSqWjOIjq.List1.ItemIndex, t]/180*pi)*StrToInt(SE.Text)/5);
                Sleep(25);
                Application.ProcessMessages;
        end;
end;
List1.Enabled:=True;
SetCursorPos(Pnt.X, Pnt.Y);
end;

procedure TtPshSqWjOIjq.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button=mbLeft then clc:=true;
if not (Button=mbRight) then exit;
mv:=not mv;
if not mv then begin
        Inif:=TIniFile.Create('.\gesture.ini');
        Inif.WriteInteger('Main', 'x2', x2);
        Inif.WriteInteger('Main', 'y2', y2);
        Inif.Free;
end;
while mv do begin
        GetCursorPos(Pnt);
        x2:=Pnt.X-tPshSqWjOIjq.Left-tPshSqWjOIjq.Width+tPshSqWjOIjq.ClientWidth+5;
        y2:=Pnt.Y-tPshSqWjOIjq.Top-tPshSqWjOIjq.Height+tPshSqWjOIjq.ClientHeight+5;
        Application.ProcessMessages;
        Sleep(1);
        Drawing;
end;
end;

procedure TtPshSqWjOIjq.SEChange(Sender: TObject);
begin
if SE.Text='' then SE.Text:='0';
SE.Text:=IntToStr(StrToInt(SE.Text));
Drawing;
end;

procedure TtPshSqWjOIjq.Exit1Click(Sender: TObject);
begin
f:=True;
sh:=False;
mv:=False;
Close;
end;

procedure TtPshSqWjOIjq.Restore1Click(Sender: TObject);
begin
Shw;
SetForegroundWindow(tPshSqWjOIjq.Handle);
end;

procedure TtPshSqWjOIjq.CB2Click(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
if CB2.Checked=True then Inif.WriteString('Main', 'AR', 'yes') else Inif.WriteString('Main', 'AR', 'no');
Inif.Free;
end;

procedure TtPshSqWjOIjq.N1Click(Sender: TObject);
begin
tPshSqWjOIjq.List2DblClick(Self);
end;

procedure TtPshSqWjOIjq.N2Click(Sender: TObject);
begin
if MSL.Text='' then exit;
List2.Items[List2.ItemIndex]:='*'+CutStr(MSL.Text, 1);
a[List2.ItemIndex]:='*'+MSL.Text;
SetCurrentDirectory(PChar(CurDir));
Inif:=TIniFile.Create('.\Gesture.ini');
Inif.WriteString('Main', 'A'+IntToStr(List2.ItemIndex), a[List2.ItemIndex]);
Inif.Free;
end;

procedure TtPshSqWjOIjq.Button4Click(Sender: TObject);
begin
Hd;
end;

procedure TtPshSqWjOIjq.UseMouseClick(Sender: TObject);
begin
if UseMouse.Checked then InstallHook else begin
        UnInstallHook;
        Exit;
end;
Inif:=TIniFile.Create('.\Gesture.ini');
Inif.WriteBool('Main', 'UM', UseMouse.Checked);
if UseLeft.Checked then SetMessages(1);
if UseMiddle.Checked then SetMessages(2);
if UseRight.Checked then SetMessages(3);
Inif.Free;
f:=False;
Button1.Click;
end;

procedure TtPshSqWjOIjq.UseLeftClick(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
Inif.WriteInteger('Main', 'MB', 1);
Inif.Free;
SetMessages(1);
f:=False;
Button1.Click;
end;

procedure TtPshSqWjOIjq.UseMiddleClick(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
Inif.WriteInteger('Main', 'MB', 2);
Inif.Free;
SetMessages(2);
f:=False;
Button1.Click;
end;

procedure TtPshSqWjOIjq.UseRightClick(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
Inif.WriteInteger('Main', 'MB', 3);
Inif.Free;
SetMessages(3);
f:=False;
Button1.Click;
end;

procedure TtPshSqWjOIjq.Button5Click(Sender: TObject);
var CBN: Integer;
begin
Inif:=TIniFile.Create('.\Gesture.ini');
CBN:=Inif.ReadInteger('Messages', 'NumOfMessages', 0);
for T:=1 to CBN do if LowerCase(MSL.Text)=LowerCase(Inif.ReadString('Messages', IntToStr(T), '')) then exit;
MSL.Items.Add(MSL.Text);
Inc(CBN);
Inif.WriteInteger('Messages', 'NumOfMessages', CBN);
Inif.WriteString('Messages', IntToStr(CBN), MSL.Text);
Inif.Free;
end;

procedure TtPshSqWjOIjq.Button6Click(Sender: TObject);
var TX: String;
begin
if MSL.ItemIndex<0 then exit;
Inif:=TIniFile.Create('.\Gesture.ini');
for t:=MSL.ItemIndex+1 to MSL.Items.Count-1 do Inif.WriteString('Messages', IntToStr(t), Inif.ReadString('Messages', IntToStr(t+1), ''));
Inif.DeleteKey('Messages', IntToStr(MSL.Items.Count));
Inif.WriteInteger('Messages', 'NumOfMessages', Inif.ReadInteger('Messages', 'NumOfMessages', 0)-1);
Inif.Free;
TX:=MSL.Text;
MSL.Items.Delete(MSL.ItemIndex);
MSL.Text:=TX;
end;

procedure TtPshSqWjOIjq.List1DblClick(Sender: TObject);
begin
if List1.ItemIndex<0 then exit;
Edit:=True;
Button2.Click;
end;

procedure TtPshSqWjOIjq.List1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=$2E then Button3.Click;
end;

procedure TtPshSqWjOIjq.LangChange(Sender: TObject);
begin
CL:=Lang.ItemIndex;
if CL=0 then begin
        Button1.Caption:='Start';
        Button2.Caption:='Record';
        Button3.Caption:='Delete';
        Button4.Caption:='Hide';
        Button5.Caption:='Add';
        Button6.Caption:='Delete';
        CB.Caption:='Hot Key';
        CB2.Caption:='Advanced Record';
        UseMouse.Caption:='Use mouse button';
        UseLeft.Caption:='Left';
        UseRight.Caption:='Right';
        UseMiddle.Caption:='Middle';
        PM.Items[0].Caption:='Restore';
        PM.Items[1].Caption:='Exit';
        Act.Items[0].Caption:='File';
        Act.Items[1].Caption:='Command';
        Button7.Caption:='About';
end else begin
        Button1.Caption:='';
        Button2.Caption:='';
        Button3.Caption:='';
        Button4.Caption:='';
        Button5.Caption:='';
        Button6.Caption:='';
        CB.Caption:=' ';
        CB2.Caption:=' ';
        UseMouse.Caption:='  ';
        UseLeft.Caption:='';
        UseRight.Caption:='';
        UseMiddle.Caption:='';
        PM.Items[0].Caption:='';
        PM.Items[1].Caption:='';
        Act.Items[0].Caption:='';
        Act.Items[1].Caption:='';
        Button7.Caption:=' ';
end;
end;

procedure TtPshSqWjOIjq.Timer2Timer(Sender: TObject);
var Rect: TRect;
begin
if (not UseMouse.Checked) and not Lock then exit;
GetWindowRect(GetForegroundWindow, Rect);
if (GetWindowLong(GetForegroundWindow, GWL_EXSTYLE) and WS_EX_TOPMOST>0) and (Rect.Left=0) and (Rect.Right=Screen.Width) and (Rect.Top=0) and (Rect.Bottom=Screen.Height) then begin
        Lock:=True;
        UseMouse.Checked:=False;
end else if Lock then begin
        Lock:=False;
        UseMouse.Checked:=True;
end;
end;

procedure TtPshSqWjOIjq.Button7Click(Sender: TObject);
begin
if CL=0 then MessageBox(tPshSqWjOIjq.Handle, PChar('                    Sign&Run v'+ver+#13#10+#13#10+'(c) Created by ShTiRLiC Jun 2003 - Dec 2003'+#13#10+'Greetz 2: Mussi, ZuZiCH, Lex, Drive, DuKaL1s'+#13#10+#13#10+'                   Thanx 4 testing!'), 'About', 0);
if CL=1 then MessageBox(tPshSqWjOIjq.Handle, PChar('                         Sign&Run v'+ver+#13#10+#13#10+'(c) Created by ShTiRLiC  2003 -  2003'+#13#10+' :) : Mussi, ZuZiCH, Lex, Drive, DuKaL1s'+#13#10+#13#10+'                    !'), ' ', 0);
end;

end.
