library Parser;

uses
  Windows, Messages, Dialogs;

var Chrs: Array[0..255] of String;
    f: Integer;
    Buf: Array[0..9] of Char;

function mciSendString(lpstrCommand, lpstrReturnString: PAnsiChar; uReturnLength: UINT; hWndCallback: HWND): DWORD; stdcall; external 'winmm.dll' name 'mciSendStringA';

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function sTextToVK(Str: String): Integer;
begin
Str:=LowerCase(Str);
for f:=0 to 255 do begin
        if Str=Chrs[f] then Break;
end;
if f=256 then f:=-1;
Result:=f;
end;

function CutStr(Str: String; WordNum: Integer): String;
var Pss: Integer;
    NMW: Integer;
begin
pss:=0;
Result:='';
NMW:=0;
While WordNum>0 do begin
        Inc(Pss);
        NMW:=Pss;
        while (Pss<Length(str)) and (Str[Pss]<>';') do Inc(Pss);
        Dec(WordNum);
        if (Pss=Length(str)) and (WordNum>0) then Exit;
        if Pss=Length(str) then break;
end;
Result:=Copy(Str, NMW, Pss-NMW);
end;

function ParseScript(Str: PChar): Boolean; stdcall;
var outs: String;
    cn: Integer;
    Key: Integer;
    KeyS, KeyS2: String;
    Txt: Char;
begin
cn:=2;
outs:=CutStr(Str, cn);
if outs<>'' then outs:=CharLower(PChar(outs)) else outs:='';
Result:=True;
while outs<>'' do begin
//        MessageBox(0, PChar(outs), 'Hello!', 0);
        if outs='/mn' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MINIMIZE, 0);
        if outs='/mx' then if IsZoomed(GetForegroundWindow) then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_RESTORE, 0) else SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
        if outs='/cl' then SendMessage(GetForegroundWindow, WM_SYSCOMMAND, SC_CLOSE, 0);
        if outs='/tm' then SetWindowPos(GetForegroundWindow, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs='/ntm' then SetWindowPos(GetForegroundWindow, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
        if outs='/cdo' then mciSendString('Set cdaudio door open wait', nil, 0, 0);
        if outs='/cdc' then mciSendString('Set cdaudio door closed wait', nil, 0, 0);
        if outs[1]='+' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
        end;
        if outs[1]='-' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP	, 0);
        end;
        if outs[1]='*' then begin
                KeyS:=LowerCase(Copy(outs, 2, Length(Outs)-1));
                Key:=sTextToVK(KeyS);
                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP	, 0);
        end;
        if outs='/txt' then begin
                Inc(cn);
                outs:=CutStr(Str, cn);
                for f:=1 to Length(outs) do begin
                        KeyS:=outs[f];
                        KeyS2:=outs[f];
                        CharUpper(PChar(KeyS2));
                        if KeyS=KeyS2 then begin
                                keybd_event($10, MapVirtualKey($10, 0), 0, 0);
                                Key:=Ord(KeyS2[1]);
                                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
                                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP, 0);
                                keybd_event($10, MapVirtualKey($10, 0), KEYEVENTF_KEYUP, 0);
                        end else begin
                                Key:=Ord(KeyS2[1]);
                                keybd_event(Key, MapVirtualKey(Key, 0), 0, 0);
                                keybd_event(Key, MapVirtualKey(Key, 0), KEYEVENTF_KEYUP, 0);
                        end;
                end;
        end;
        Inc(cn);
        outs:=CutStr(Str, cn);
//        ShowMessage(outs);
        if outs<>'' then outs:=CharLower(PChar(outs)) else outs:='';
end;
end;

exports ParseScript;

begin
// Init key table
for f:=0 to 255 do begin
        GetKeyNameText(MapVirtualKey(f,0) shl 16, @Buf, 256);
        Chrs[f]:=LowerCase(Buf);
end;
Chrs[$03]:='cancel';
Chrs[$0c]:='clear';
Chrs[$13]:='pause';
Chrs[$20]:='space';
Chrs[$21]:='pgup';
Chrs[$22]:='pgdn';
Chrs[$23]:='end';
Chrs[$24]:='home';
Chrs[$25]:='left';
Chrs[$26]:='up';
Chrs[$27]:='right';
Chrs[$28]:='down';
Chrs[$29]:='select';
Chrs[$2d]:='ins';
Chrs[$2e]:='del';
Chrs[$5b]:='lwin';
Chrs[$5c]:='rwin';
Chrs[$5d]:='apps';
end.
